import { ASTFeatureEnvarExpression } from 'greybel-core';
import { ASTBase, ASTCallExpression, ASTEvaluationExpression, ASTFunctionStatement, ASTIdentifier, ASTIndexExpression, ASTListConstructorExpression, ASTLiteral, ASTMapConstructorExpression, ASTMemberExpression, ASTSliceExpression, ASTUnaryExpression } from 'miniscript-core';
import { Context } from './context';
import { LineCallableContext, LineContext, LineIdentifierContext } from './line';
import { IBytecodeExpressionGenerator, IBytecodeStatementGenerator, ParseCodeFunction } from './models';
export declare class BytecodeExpressionGenerator implements IBytecodeExpressionGenerator {
    protected context: Context;
    protected stmtGenerator: IBytecodeStatementGenerator;
    protected parseCode: ParseCodeFunction;
    constructor(context: Context, parseCodeFunction: ParseCodeFunction, stmtGenerator: IBytecodeStatementGenerator);
    process(node: ASTBase, context?: LineContext): Promise<void>;
    processMemberExpression(node: ASTMemberExpression, context?: LineCallableContext): Promise<void>;
    processIndexExpression(node: ASTIndexExpression): Promise<void>;
    processSliceExpression(node: ASTSliceExpression): Promise<void>;
    processIdentifier(node: ASTIdentifier, context?: LineIdentifierContext): Promise<void>;
    processLiteral(node: ASTLiteral): Promise<void>;
    processEvaluationExpression(node: ASTEvaluationExpression): Promise<void>;
    processMapConstructorExpression(node: ASTMapConstructorExpression): Promise<void>;
    processListConstructorExpression(node: ASTListConstructorExpression): Promise<void>;
    processFunctionDeclaration(node: ASTFunctionStatement, context?: LineContext): Promise<void>;
    processUnaryExpression(node: ASTUnaryExpression): Promise<void>;
    processCallExpression(node: ASTCallExpression): Promise<void>;
    processEnvarExpression(node: ASTFeatureEnvarExpression): Promise<void>;
}
