import { ASTBase } from 'miniscript-core';
import { Stack } from '../utils/stack';
import { Instruction, SourceLocation } from './instruction';
export interface BytecodeGeneratorContext {
    code: Instruction[];
    jumpPoints: [Instruction, Instruction][];
}
export declare class Module {
    protected _target: string;
    protected _context: Stack<BytecodeGeneratorContext>;
    constructor(target: string);
    get target(): string;
    get context(): Stack<BytecodeGeneratorContext>;
    isGlobalScope(): boolean;
    pushContext(): void;
    popContext(): BytecodeGeneratorContext;
    getCurrentIp(): number;
    getCode(): Instruction[];
    pushCode(item: Instruction): void;
    getJumpPoint(): [Instruction, Instruction];
    pushJumppoint(start: Instruction, end: Instruction): void;
    popJumppoint(): [Instruction, Instruction];
    getSourceLocation(node: ASTBase, name?: string): SourceLocation;
    getInternalLocation(): SourceLocation;
}
