"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.unwrap = exports.generateCustomValueFromASTLiteral = void 0;
const miniscript_core_1 = require("miniscript-core");
const boolean_1 = require("../types/boolean");
const default_1 = require("../types/default");
const number_1 = require("../types/number");
const string_1 = require("../types/string");
function generateCustomValueFromASTLiteral(node) {
    switch (node.type) {
        case miniscript_core_1.ASTType.BooleanLiteral:
            return new boolean_1.CustomBoolean(node.value);
        case miniscript_core_1.ASTType.StringLiteral:
            return new string_1.CustomString(node.value);
        case miniscript_core_1.ASTType.NumericLiteral:
            return new number_1.CustomNumber(node.value);
        case miniscript_core_1.ASTType.NilLiteral:
            return default_1.DefaultType.Void;
        default:
            throw new Error('Unexpected literal type.');
    }
}
exports.generateCustomValueFromASTLiteral = generateCustomValueFromASTLiteral;
function unwrap(node) {
    while (node instanceof miniscript_core_1.ASTParenthesisExpression) {
        node = node.expression;
    }
    return node;
}
exports.unwrap = unwrap;
