"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getStringHashCode = exports.getHashCode = exports.rotateBits = void 0;
function rotateBits(n) {
    return (n >> 1) | (n << 31);
}
exports.rotateBits = rotateBits;
function getHashCode(value, offset = 0) {
    let unsigned = value >>> 0;
    unsigned = ((unsigned >> 16) ^ unsigned) * 0x45d9f3b;
    unsigned = ((unsigned >> 16) ^ unsigned) * 0x45d9f3b;
    unsigned = (unsigned >> 16) ^ unsigned;
    return ((offset << 5) - offset + unsigned) | 0;
}
exports.getHashCode = getHashCode;
exports.getStringHashCode = (function () {
    const cache = new Map();
    const generateHash = (s) => {
        for (var i = 0, h = 0; i < s.length; i++)
            h = (Math.imul(31, h) + s.charCodeAt(i)) | 0;
        return h;
    };
    return (value) => {
        if (value.length === 0) {
            return 0;
        }
        const cachedHash = cache.get(value);
        if (cachedHash !== undefined) {
            return cachedHash;
        }
        const hash = generateHash(value);
        cache.set(value, hash);
        return hash;
    };
})();
